commit 75cc4527ffcdd11063e1631068f0656db67f9c29
Author: Hans P. Schlaepfer <hanspeter.schlaepfer@revamp-it.ch>
Date:   Fri Jul 26 09:21:34 2019 +0200

    Neues Design 2019 Standard-Code templates/webpages/am/edit_templates.html

diff --git a/templates/webpages/am/edit_templates.html b/templates/webpages/am/edit_templates.html
index c5cf15bbb..6e60c760b 100644
--- a/templates/webpages/am/edit_templates.html
+++ b/templates/webpages/am/edit_templates.html
@@ -1,61 +1,69 @@
- <h1>[% title %]</h1>
-
-  [% IF type == 'templates' %]
-   <p style="text-align: right;">[<a href="doc/html/ch03s03.html" target="_blank" title="[% 'Open in new window' | $T8 %]">[% 'Help Template Variables' | $T8 %]</a>]</p>
-  [% END %]
-
- <form method="post" name="Form" action="amtemplates.pl" id="form">
-
-  [% FOREACH var = HIDDEN %]<input type="hidden" name="[% HTML.escape(var.name) %]" value="[% HTML.escape(var.value) %]">[% END %]
-
-  [% IF SHOW_EDIT_OPTIONS %]
-   <p>
-    [% 'Template' | $T8 %]
-    <select name="formname">
-     [% FOREACH row = FORMNAME %]<option value="[% HTML.escape(row.value) %]" [% IF row.value == formname %]selected[% END %]>[% HTML.escape(row.label) %]</option>[% END %]
-    </select>
-
 [% USE T8 %]
 [% USE HTML %]
+
+<h1>[% title %]</h1>
+
+[% IF type == 'templates' %]
+  <p style="text-align: right;">[<a href="doc/html/ch03s03.html" target="_blank" title="[% 'Open in new window' | $T8 %]">[% 'Help Template Variables' | $T8 %]</a>]</p>
+[% END %]
+
+<form method="post" name="Form" action="amtemplates.pl" id="form">
+[% FOREACH var = HIDDEN %]<input type="hidden" name="[% HTML.escape(var.name) %]" value="[% HTML.escape(var.value) %]">[% END %]
+
+[% IF SHOW_EDIT_OPTIONS %]
+<table class="tbl-horizontal">
+  <caption>[% '' | $T8 %]</caption>
+  <colgroup> <col class="wi-small"><col class="wi-lightwide"> </colgroup>
+  <tbody>
+    <tr>
+      <th>[% 'Template' | $T8 %]</th>
+      <td>
+        <select name="formname">
+          [% FOREACH row = FORMNAME %]<option value="[% HTML.escape(row.value) %]" [% IF row.value == formname %]selected[% END %]>[% HTML.escape(row.label) %]</option>[% END %]
+        </select>
+      </td>
+    </tr>
     [% IF LANGUAGE.size %]
-     [% 'Language' | $T8 %]
-     <select name="language">
-      <option></option>
-      [% FOREACH row = LANGUAGE %]<option value="[% HTML.escape(row.value) %]" [% IF row.value == language %]selected[% END %]>[% HTML.escape(row.label) %]</option>[% END %]
-     </select>
+    <tr>
+      <th>[% 'Language' | $T8 %]</th>
+      <td>
+        <select name="language">
+          <option></option>
+          [% FOREACH row = LANGUAGE %]<option value="[% HTML.escape(row.value) %]" [% IF row.value == language %]selected[% END %]>[% HTML.escape(row.label) %]</option>[% END %]
+        </select>
+      </td>
+    </tr>
     [% END %]
-
     [% IF PRINTER.size %]
-     [% 'Printer' | $T8 %]
-     <select name="printer">
-      <option></option>
-      [% FOREACH row = PRINTER %]<option value="[% HTML.escape(row.value) %]" [% IF row.value == printer %]selected[% END %]>[% HTML.escape(row.label) %]</option>[% END %]
-     </select>
+    <tr>
+      <th>[% 'Printer' | $T8 %]</th>
+      <td>
+      <select name="printer">
+        <option></option>
+        [% FOREACH row = PRINTER %]<option value="[% HTML.escape(row.value) %]" [% IF row.value == printer %]selected[% END %]>[% HTML.escape(row.label) %]</option>[% END %]
+      </select>
+      </td>
+    </tr>
     [% END %]
+  </tbody>
+</table>
 
-    <input type="hidden" name="display_nextsub" value="display_template">
+<input type="hidden" name="display_nextsub" value="display_template">
+<input name="action" type="submit" value="[% 'Display' | $T8 %]">
+[% END %]
 
-    <input name="action" type="submit" class="submit" value="[% 'Display' | $T8 %]">
+[% IF SHOW_CONTENT %]
+  <h2>
+    [% IF CAN_EDIT %][% 'Edit file' | $T8 %][% ELSE %][% 'Display file' | $T8 %][% END %]
+    [% HTML.escape(display_filename) %]
+  </h2>
 
-   </p>
-
-   <hr>
-  [% END %]
-
-  [% IF SHOW_CONTENT %]
-    <h2>
-     [% IF CAN_EDIT %][% 'Edit file' | $T8 %][% ELSE %][% 'Display file' | $T8 %][% END %] [% HTML.escape(display_filename) %]
-    </h2>
-
-   [% IF CAN_EDIT %]
+  [% IF CAN_EDIT %]
     <p><textarea name="content" id="edit_content" cols="100" rows="25"[% IF edit %] class="initial_focus"[% END %]>[% HTML.escape(content) %]</textarea></p>
-
-    [% ELSE %]
-
+  [% ELSE %]
     <p><pre class="filecontent">[% HTML.escape(content) %]</pre></p>
+  [% END %] <!-- CAN_EDIT -->
 
-   [% END %] <!-- CAN_EDIT -->
-
-  [% END %] <!-- SHOW_CONTENT -->
+[% END %] <!-- SHOW_CONTENT -->
 
- </form>
+</form>