commit f3c78a027b8d2709c41f803852706c72cc355eb2
Author: Martin Helmling <martin.helmling@octosoft.eu>
Date:   Thu Dec 22 12:14:54 2016 +0100

    Artikel-Klassifizierung: Dokumentation

diff --git a/doc/changelog b/doc/changelog
index 3bf706f3e..4b20a50bc 100644
--- a/doc/changelog
+++ b/doc/changelog
@@ -4,6 +4,45 @@
 
 2017-xx-xx - Release 3.4.x Unstable
 
+große Features:
+
+- Artikel-Klassifizierung
+
+  Die Klassifizierung von Artikeln dient einer weiteren Gliederung um
+  zum Beispiel den Einkauf vom Verkauf zu trennen, etc.
+
+  Gekennzeichnet durch eine Beschreibung (z.B. "Einkauf") und ein Kürzel (z.B. "E")
+  Flexibel änderbar und erweiterbar.
+
+  Der Typ des Artikel und die Klassifizierung werden durch zwei
+  Buchstaben dargestellt.  Der erste Buchstabe ist eine Lokalisierung
+  des Typs des Artikel ('P','A','S') , deutch 'W', 'E', und 'D' für
+  Ware Erzeugnis oder Dienstleistung, ggf. weitere Typen.  Der zweite
+  Buchstabe ist eine Lokalisierung der Klassifizierungsabkürzung
+  (abbreviation).
+
+  Wenn im ERP-Dokument nach einer Artikelnummer oder Beschreibung
+  gesucht wird, diese in den Stammdaten vorhanden ist, aber der
+  Artikeltyp falsch ist, wird die Fehlermeldung "Gesuchter Artikel ist
+  nicht für den Einkauf bzw Verkauf" gemeldet.
+
+  Anpassung des CSV Import, nun wird alternativ zur 'part_type'-Spalte
+  die 'pclass'-Spalte mit zwei bis drei Buchstaben geparsed und entsprechend
+  classification_id und part_type gesetzt.
+
+- Option "Preis separat ausweisen" als neue Artikel-Klassifizierung
+
+  Die Option ist unter Artikelklassifikation editierbar.  In Aufträgen
+  und Rechnungen werden die Zwischensummen dem Drucksystem zur
+  Verfügung gestellt. Die verwendbaren Variablen sind:
+
+  -  <%separate_XX_subtotal%>  wobei XX die Abkürzung der Klassifikation ist.
+  -  <%non_separate_subtotal%> der Rest der Positionen.
+
+  Hintergrund:
+     Preise von Artikeln wie "Verpackung" oder "Transport" müssen
+     oftmals separat ausgewiesen werden, genau so wie der reine Warenwert.
+
 kleinere neue Features und Detailverbesserungen:
 
   - SEPA Überweisungen zusätzlich Kunden- oder Lieferantennummer im Verwendungszweck vorbelegen
diff --git a/doc/dokumentation.xml b/doc/dokumentation.xml
index 0eb1542ea..463106c46 100644
--- a/doc/dokumentation.xml
+++ b/doc/dokumentation.xml
@@ -6220,6 +6220,115 @@ Beschreibung: &lt;%description%&gt;
 	  Vorschläge für weitere (z.B. branchenspezifische) Kontenpläne
 	  bitte an <literal>empfang@revamp-it.ch</literal> senden.</para>
     </sect1>
+    <sect1>
+      <title>Artikelklassifizierung</title>
+
+      <sect2>
+        <title>Übersicht</title>
+
+        <para>Die Klassifizierung von Artikeln dient einer weiteren Gliederung
+        um zum Beispiel den Einkauf vom Verkauf zu trennen, gekennzeichnet
+        durch eine Beschreibung (z.B. "Einkauf") und ein Kürzel (z.B. "E").
+        Für jede Klassifizierung besteht eine Beschreibung und eine Abkürzung
+        die normalerweise aus einem Zeichen besteht, kann aber auf mehrere
+        Zeichen erweitert werden, falls zur Unterscheidung notwendig, sinnvoll
+        sind jedoch nur maximal 2 Zeichen.</para>
+      </sect2>
+
+      <sect2>
+        <title>Basisklassifizierung</title>
+
+        <para>Als Basisklassifizierungen gibt es</para>
+
+        <itemizedlist>
+          <listitem>
+            <para>Einkauf</para>
+          </listitem>
+
+          <listitem>
+            <para>Verkauf</para>
+          </listitem>
+
+          <listitem>
+            <para>Handelsware</para>
+          </listitem>
+
+          <listitem>
+            <para>Produktion</para>
+          </listitem>
+
+          <listitem>
+            <para>- keine - (diese wird bei einer Aktualisierung für alle
+            existierenden Artikel genommen, gültig für Verkauf und
+            Einkauf)</para>
+          </listitem>
+        </itemizedlist>
+
+        <para>Es können weitere Klassifizierungen angelegt werden. So kann es
+        z.B. für separat auszuweisende Artikel folgened Klassen geben:</para>
+
+        <orderedlist>
+          <listitem>
+            <para>Lieferung (Logistik, Transport) mit Kürzel L</para>
+          </listitem>
+
+          <listitem>
+            <para>Material (Verpackungsmaterial) mit Kürzel M</para>
+          </listitem>
+        </orderedlist>
+      </sect2>
+
+      <sect2>
+        <title>Attribute</title>
+
+        <para>Bisher haben die Klassifizierungen folgende Attribute, die auch
+        alle gleichzeitg gültig sein können</para>
+
+        <itemizedlist>
+          <listitem>
+            <para>gültig für Verkauf - dieser Artikel kann im Verkauf genutzt
+            werden</para>
+          </listitem>
+
+          <listitem>
+            <para>gültig für Einkauf - dieser Artikel kann im Einkauf genutzt
+            werden</para>
+          </listitem>
+
+          <listitem>
+            <para>separat ausweisen - hierzu gibt es zur Dokumentengenerierung
+            (LaTeX) zusätzliche Variable</para>
+          </listitem>
+        </itemizedlist>
+
+        <para>Beim separat ausweisen stehen im LaTeX die Variable <emphasis
+        role="bold">&lt;%non_separate_subtotal%&gt; </emphasis>zur Verfügung,
+        die alle nicht separat auszuweisenden Artikelkosten saldiert, sowie
+        pro separat auszuweisenden Klassifizierungen die Variable<emphasis
+        role="bold"> &lt;%separate_X_subtotal%&gt;</emphasis> wobei X das
+        Kürzel der Klassifizierung ist.</para>
+
+        <para>Im obigen Beispiel wäre das für Lieferkosten <emphasis
+        role="bold">&lt;%separate_L_subtotal%&gt;</emphasis> und für
+        Verpackungsmaterial <emphasis
+        role="bold">&lt;%separate_M_subtotal%&gt; </emphasis>.</para>
+      </sect2>
+
+      <sect2>
+        <title>Zwei-Zeichen Abkürzung</title>
+
+        <para>Der Typ des Artikel und die Klassifizierung werden durch zwei
+        Buchstaben dargestellt. Der erste Buchstabe ist eine Lokalisierung des
+        Typs des Artikel ('P','A','S') , deutch 'W', 'E', und 'D' für Ware
+        Erzeugnis oder Dienstleistung, ggf. weitere Typen.</para>
+
+        <para>Der zweite (und ggf. auch ein dritter Buchstabe, falls nötig)
+        entspricht der lokalisierten Abkürzung der Klassifizierung.</para>
+
+        <para>Diese Abkürzung wird überall beim Auflisten von Artikeln zur
+        Erleichterung mit dargestellt.</para>
+      </sect2>
+    </sect1>
   </chapter>
 
   <chapter>