commit 82c3a3c9b6cef4cfa1719bb34c69cb181ad6c746
Author: Hans P. Schlaepfer <hanspeter.schlaepfer@revamp-it.ch>
Date:   Sun Jul 28 16:17:46 2019 +0200

    Neues Design 2019 Standard-Code templates/webpages/admin/show.html

diff --git a/templates/webpages/admin/show.html b/templates/webpages/admin/show.html
index d0e5ccb46..3d1d6f210 100644
--- a/templates/webpages/admin/show.html
+++ b/templates/webpages/admin/show.html
@@ -7,100 +7,109 @@
 <h1>[% HTML.escape(title) %]</h1>
 
 <div class="tabwidget">
- <ul>
-  <li><a href="#user_list">[%- LxERP.t8("User list") %]</a></li>
-  <li><a href="#client_list">[%- LxERP.t8("Client list") %]</a></li>
-  <li><a href="#group_list">[%- LxERP.t8("Group list") %]</a></li>
- </ul>
+  <ul>
+    <li><a href="#user_list">[% LxERP.t8("User list") %]</a></li>
+    <li><a href="#client_list">[% LxERP.t8("Client list") %]</a></li>
+    <li><a href="#group_list">[% LxERP.t8("Group list") %]</a></li>
+  </ul>
+  <div id="user_list">
+  [% IF !SELF.all_users.size %]
+    <p>
+      [% LxERP.t8("No users have been created yet.") %]
+      [% LxERP.t8("In order to use kivitendo you have to create at least a client, a user and a group.") %]
+    </p>
+  [% ELSE %]
+    <table class="tbl-list">
+      <caption>[% LxERP.t8('Users') %]</caption>
+      <thead>
+        <tr>
+          <th>[% LxERP.t8('Login Name') %]</th>
+          <th>[% LxERP.t8('Name') %]</th>
+          <th>[% LxERP.t8('Language') %]</th>
+        </tr>
+      </thead>
+      <tbody>
+      [% FOREACH user = SELF.all_users %]
+        [% SET config = user.config_values %]
+        <tr>
+          <td>[% L.link(SELF.url_for(action="edit_user", id=user.id), HTML.escape(user.login)) %]</td>
+          <td>[% HTML.escape(config.name) %]</td>
+          <td>[% HTML.escape(config.countrycode) %]</td>
+        </tr>
+      [% END %]
+      </tbody>
+    </table>
+  [% END %]
+</div>
 
- <div id="user_list">
-[%- IF !SELF.all_users.size %]
+<div id="client_list">
+[% IF !SELF.all_clients.size %]
   <p>
-   [% LxERP.t8("No users have been created yet.") %]
-   [% LxERP.t8("In order to use kivitendo you have to create at least a client, a user and a group.") %]
+    [% LxERP.t8("No clients have been created yet.") %]
+    [% LxERP.t8("In order to use kivitendo you have to create at least a client, a user and a group.") %]
   </p>
-
-[%- ELSE %]
-  <table width="100%">
-   <tr class="listheading">
-    <th>[% LxERP.t8('Login Name') %]</th>
-    <th>[% LxERP.t8('Name') %]</th>
-    <th>[% LxERP.t8('Language') %]</th>
-   </tr>
-
-[% FOREACH user = SELF.all_users %]
-[%- SET config = user.config_values %]
-   <tr class="listrow">
-    <td>[% L.link(SELF.url_for(action="edit_user", id=user.id), HTML.escape(user.login)) %]</td>
-    <td>[% HTML.escape(config.name) %]</td>
-    <td>[% HTML.escape(config.countrycode) %]</td>
-   </tr>
-[% END %]
+[% ELSE %]
+  <table class="tbl-list">
+    <caption>[% LxERP.t8('Clients') %]</caption>
+    <thead>
+    <tr>
+      <th>[% LxERP.t8('Database ID') %]</th>
+      <th>[% LxERP.t8('Client name') %]</th>
+      <th>[% LxERP.t8('Database name') %]</th>
+      <th>[% LxERP.t8('Database Host') %]</th>
+      <th>[% LxERP.t8('Database User') %]</th>
+      <th>[% LxERP.t8('Default client') %]</th>
+      <th>[% LxERP.t8('Task server') %]</th>
+    </tr>
+    </thead>
+    <tbody>
+    [% FOREACH client = SELF.all_clients %]
+      <tr>
+        <td>[% L.link(SELF.url_for(action="edit_client", id=client.id), HTML.escape(client.id)) %]</td>
+        <td>[% L.link(SELF.url_for(action="edit_client", id=client.id), HTML.escape(client.name)) %]</td>
+        <td>[% HTML.escape(client.dbname) %]</td>
+        <td>[% HTML.escape(client.dbhost) %][% IF client.dbport %]:[% HTML.escape(client.dbport) %][% END %]</td>
+        <td>[% HTML.escape(client.dbuser) %]</td>
+        <td>[% IF client.is_default %][% LxERP.t8("Yes") %][% ELSE %][% LxERP.t8("No") %][% END %]</td>
+        <td>
+         [% IF client.task_server_user %]
+          [% LxERP.t8("execution as user '#1'", client.task_server_user.login) %]
+         [% ELSE %]
+          [% LxERP.t8("no execution for this client") %]
+         [% END %]
+        </td>
+      </tr>
+    [% END %]
+    </tbody>
   </table>
-[%- END %]
- </div>
-
- <div id="client_list">
-[%- IF !SELF.all_clients.size %]
-  <p>
-   [% LxERP.t8("No clients have been created yet.") %]
-   [% LxERP.t8("In order to use kivitendo you have to create at least a client, a user and a group.") %]
-  </p>
-
-[%- ELSE %]
-  <table width="100%">
-   <tr class="listheading">
-    <th>[% LxERP.t8('Database ID') %]</th>
-    <th>[% LxERP.t8('Client name') %]</th>
-    <th>[% LxERP.t8('Database name') %]</th>
-    <th>[% LxERP.t8('Database Host') %]</th>
-    <th>[% LxERP.t8('Database User') %]</th>
-    <th>[% LxERP.t8('Default client') %]</th>
-    <th>[% LxERP.t8('Task server') %]</th>
-   </tr>
-
-[%- FOREACH client = SELF.all_clients %]
-   <tr class="listrow">
-    <td>[% L.link(SELF.url_for(action="edit_client", id=client.id), HTML.escape(client.id)) %]</td>
-    <td>[% L.link(SELF.url_for(action="edit_client", id=client.id), HTML.escape(client.name)) %]</td>
-    <td>[% HTML.escape(client.dbname) %]</td>
-    <td>[% HTML.escape(client.dbhost) %][% IF client.dbport %]:[%- HTML.escape(client.dbport) %][%- END %]</td>
-    <td>[% HTML.escape(client.dbuser) %]</td>
-    <td>[% IF client.is_default %][% LxERP.t8("Yes") %][%- ELSE %][% LxERP.t8("No") %][%- END %]</td>
-    <td>
-     [% IF client.task_server_user %]
-      [% LxERP.t8("execution as user '#1'", client.task_server_user.login) %]
-     [% ELSE %]
-      [% LxERP.t8("no execution for this client") %]
-     [% END %]
-    </td>
-   </tr>
-[%- END %]
-  </table>
-[%- END %]
- </div>
+[% END %]
+</div>
 
- <div id="group_list">
-[%- IF !SELF.all_groups.size %]
+<div id="group_list">
+[% IF !SELF.all_groups.size %]
   <p>
-   [% LxERP.t8("No groups have been created yet.") %]
-   [% LxERP.t8("In order to use kivitendo you have to create at least a client, a user and a group.") %]
+    [% LxERP.t8("No groups have been created yet.") %]
+    [% LxERP.t8("In order to use kivitendo you have to create at least a client, a user and a group.") %]
   </p>
 
-[%- ELSE %]
-  <table width="100%">
-   <tr class="listheading">
-    <th>[% LxERP.t8('Name') %]</th>
-    <th>[% LxERP.t8('Description') %]</th>
-   </tr>
-
-[%- FOREACH group = SELF.all_groups %]
-   <tr class="listrow">
-    <td>[% L.link(SELF.url_for(action="edit_group", id=group.id), HTML.escape(group.name)) %]</td>
-    <td>[% HTML.escape(group.description) %]</td>
-   </tr>
-[%- END %]
+[% ELSE %]
+  <table class="tbl-list">
+    <caption>[% LxERP.t8('Groups') %]</caption>
+    <thead>
+      <tr>
+        <th>[% LxERP.t8('Name') %]</th>
+        <th>[% LxERP.t8('Description') %]</th>
+      </tr>
+    </thead>
+    <tbody>
+[% FOREACH group = SELF.all_groups %]
+    <tr>
+      <td>[% L.link(SELF.url_for(action="edit_group", id=group.id), HTML.escape(group.name)) %]</td>
+      <td>[% HTML.escape(group.description) %]</td>
+    </tr>
+[% END %]
+    </tbody>
   </table>
-[%- END %]
- </div>
+[% END %]
+  </div>
 </div>